gtkmm: Gtk::StringSorter Class Reference

gtkmm 4.13.3

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::StringSorter Class Reference
ListView Classes

Sort by comparing strings. More...

`#include <gtkmm/stringsorter.h>`

Inheritance diagram for Gtk::StringSorter:
[legend]

## Public Member Functions
| StringSorter (StringSorter && src) noexcept
StringSorter & | operator= (StringSorter && src) noexcept
| ~StringSorter () noexcept override
GtkStringSorter * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkStringSorter * | gobj () const
| Provides access to the underlying C GObject. More...
GtkStringSorter * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::RefPtr< Expression< Glib::ustring > > | get_expression ()
| Gets the expression that is evaluated to obtain strings from items. More...
Glib::RefPtr< const Expression< Glib::ustring > > | get_expression () const
| Gets the expression that is evaluated to obtain strings from items. More...
void | set_expression (const Glib::RefPtr< Expression< Glib::ustring > > & expression)
| Sets the expression that is evaluated to obtain strings from items. More...
bool | get_ignore_case () const
| Gets whether the sorter ignores case differences. More...
void | set_ignore_case (bool ignore_case=true)
| Sets whether the sorter will ignore case differences. More...
void | set_collation (Collation collation)
| Sets the collation method to use for sorting. More...
Collation | get_collation () const
| Gets which collation method the sorter uses. More...
Glib::PropertyProxy< Glib::RefPtr< Expression< Glib::ustring > > > | property_expression ()
| The expression to evaluate on item to get a string to compare with. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Expression< Glib::ustring > > > | property_expression () const
| The expression to evaluate on item to get a string to compare with. More...
Glib::PropertyProxy< bool > | property_ignore_case ()
| If sorting is case sensitive. More...
Glib::PropertyProxy_ReadOnly< bool > | property_ignore_case () const
| If sorting is case sensitive. More...
Glib::PropertyProxy< Collation > | property_collation ()
| The collation method to use for sorting. More...
Glib::PropertyProxy_ReadOnly< Collation > | property_collation () const
| The collation method to use for sorting. More...
Public Member Functions inherited from Gtk::Sorter
| Sorter (Sorter && src) noexcept
Sorter & | operator= (Sorter && src) noexcept
| ~Sorter () noexcept override
GtkSorter * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkSorter * | gobj () const
| Provides access to the underlying C GObject. More...
GtkSorter * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Ordering | compare (gpointer item1, gpointer item2)
| Compares two given items according to the sort order implemented by the sorter. More...
Order | get_order () const
| Gets the order that self conforms to. More...
void | changed (Change change)
| Notifies all users of the sorter that it has changed. More...
Glib::SignalProxy< void(Change)> | signal_changed ()
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data_with_c_callback (const Quark &key, void *data, GDestroyNotify notify)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< StringSorter > | create (const Glib::RefPtr< Expression< Glib::ustring > > & expression)
Static Public Member Functions inherited from Gtk::Sorter
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| StringSorter (const Glib::RefPtr< Expression< Glib::ustring > > & expression)
Protected Member Functions inherited from Gtk::Sorter
| Sorter ()
virtual Ordering | compare_vfunc (gpointer item1, gpointer item2)
virtual Order | get_order_vfunc ()
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::StringSorter > | wrap (GtkStringSorter * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Sorter
Glib::RefPtr< Gtk::Sorter > | wrap (GtkSorter * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Gtk::Sorter
enum class | Order { Order::PARTIAL , Order::NONE , Order::TOTAL }
| Describes the type of order that a `Gtk::Sorter` may produce. More...
enum class | Change { Change::DIFFERENT , Change::INVERTED , Change::LESS_STRICT , Change::MORE_STRICT }
| Describes changes in a sorter in more detail and allows users to optimize resorting. More...
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

Sort by comparing strings.

Gtk::StringSorter is a Gtk::Sorter that compares strings. It does the comparison in a linguistically correct way using the current locale by normalizing Unicode strings and possibly case-folding them before performing the comparison.

To obtain the strings to compare, this sorter evaluates a Gtk::Expression.

See also
  Gtk::Expression

Since gtkmm 3.98:

## Constructor & Destructor Documentation

## ◆ StringSorter() [1/2]

Gtk::StringSorter::StringSorter | ( | StringSorter && | src | ) |
| noexcept

## ◆ ~StringSorter()

Gtk::StringSorter::~StringSorter | ( |  | ) |
| overridenoexcept

## ◆ StringSorter() [2/2]

Gtk::StringSorter::StringSorter | ( | const Glib::RefPtr< Expression< Glib::ustring > > & | expression | ) |
| explicitprotected

## Member Function Documentation

## ◆ create()

static Glib::RefPtr< StringSorter > Gtk::StringSorter::create | ( | const Glib::RefPtr< Expression< Glib::ustring > > & | expression | ) |
| static

## ◆ get_collation()

Collation Gtk::StringSorter::get_collation | ( |  | ) | const

Gets which collation method the sorter uses.

Since gtkmm 4.10:

Returns
  The collation method.

## ◆ get_expression() [1/2]

Glib::RefPtr< Expression< Glib::ustring > > Gtk::StringSorter::get_expression | ( |  | ) |

Gets the expression that is evaluated to obtain strings from items.

Returns
  A `Gtk::Expression`.

## ◆ get_expression() [2/2]

Glib::RefPtr< const Expression< Glib::ustring > > Gtk::StringSorter::get_expression | ( |  | ) | const

Gets the expression that is evaluated to obtain strings from items.

Returns
  A `Gtk::Expression`.

## ◆ get_ignore_case()

bool Gtk::StringSorter::get_ignore_case | ( |  | ) | const

Gets whether the sorter ignores case differences.

Returns
  `true` if self is ignoring case differences.

## ◆ get_type()

static GType Gtk::StringSorter::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkStringSorter * Gtk::StringSorter::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkStringSorter * Gtk::StringSorter::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkStringSorter * Gtk::StringSorter::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

StringSorter & Gtk::StringSorter::operator= | ( | StringSorter && | src | ) |
| noexcept

## ◆ property_collation() [1/2]

Glib::PropertyProxy< Collation > Gtk::StringSorter::property_collation | ( |  | ) |

The collation method to use for sorting.

The `Gtk::Collation::NONE` value is useful when the expression already returns collation keys, or strings that need to be compared byte-by-byte.

The default value, `Gtk::Collation::UNICODE`, compares strings according to the Unicode collation algorithm.

Since gtkmm 4.10:

Default value: Gtk::Collation::UNICODE

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_collation() [2/2]

Glib::PropertyProxy_ReadOnly< Collation > Gtk::StringSorter::property_collation | ( |  | ) | const

The collation method to use for sorting.

The `Gtk::Collation::NONE` value is useful when the expression already returns collation keys, or strings that need to be compared byte-by-byte.

The default value, `Gtk::Collation::UNICODE`, compares strings according to the Unicode collation algorithm.

Since gtkmm 4.10:

Default value: Gtk::Collation::UNICODE

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_expression() [1/2]

Glib::PropertyProxy< Glib::RefPtr< Expression< Glib::ustring > > > Gtk::StringSorter::property_expression | ( |  | ) |

The expression to evaluate on item to get a string to compare with.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_expression() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Expression< Glib::ustring > > > Gtk::StringSorter::property_expression | ( |  | ) | const

The expression to evaluate on item to get a string to compare with.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_ignore_case() [1/2]

Glib::PropertyProxy< bool > Gtk::StringSorter::property_ignore_case | ( |  | ) |

If sorting is case sensitive.

Default value: `true`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_ignore_case() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::StringSorter::property_ignore_case | ( |  | ) | const

If sorting is case sensitive.

Default value: `true`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ set_collation()

void Gtk::StringSorter::set_collation | ( | Collation | collation | ) |

Sets the collation method to use for sorting.

Since gtkmm 4.10:

Parameters

  collation | The collation method.

## ◆ set_expression()

void Gtk::StringSorter::set_expression | ( | const Glib::RefPtr< Expression< Glib::ustring > > & | expression | ) |

Sets the expression that is evaluated to obtain strings from items.

The expression must have the type G_TYPE_STRING.

Parameters

  expression | A `Gtk::Expression`.

## ◆ set_ignore_case()

void Gtk::StringSorter::set_ignore_case | ( | bool | ignore_case = `true` | ) |

Sets whether the sorter will ignore case differences.

Parameters

  ignore_case | `true` to ignore case differences.

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::StringSorter > wrap | ( | GtkStringSorter * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.